



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Codeforces 946D - Timetable (预处理+分组背包)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Codeforces 946D - Timetable (预处理+分组背包)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 07:43:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：<a href="http://codeforces.com/contest/946/problem/D" rel="external nofollow noreferrer">Timetable</a></p>
<p>题意：Ivan是一个学生，在一个Berland周内要上n天课，每天最多会有m节，他能逃课的最大数量是k。求他在学校的时间最小是多少？</p>
<p>题解：先把每天逃课x节在学校呆的最小时间预处理出来，这样就变成了在n天里面，每个组有不同的情况，找出逃课t节的能在学校呆最小时间的情况。就是一个分组背包问题了。</p>
<div>
<pre class="prettyprint linenums"> #include&lt;bits/stdc++.h&gt;<br />
 using namespace std;<br />
 const int MAX_N = 5e2+;<br />
 const int INF = 1e9+;<br />
 int N,M,T,S;<br />
 int num[MAX_N];<br />
 int pos[MAX_N][MAX_N];<br />
 char vec[MAX_N][MAX_N];<br />
 int v[MAX_N][MAX_N];<br />
 int dp[MAX_N];<br />
 int main(){<br />
     while(cin&gt;&gt;N&gt;&gt;M&gt;&gt;T){<br />
         memset(num,,sizeof(num));<br />
         for(int i=;i&lt;MAX_N;i++) memset(pos[i],,sizeof(pos[i]));<br />
         for(int i=;i&lt;N;i++){<br />
             scanf("%s",vec[i]);<br />
             for(int j=;j&lt;M;j++){<br />
                 if(vec[i][j] == ''){<br />
                     num[i] ++ ;<br />
                     pos[i][num[i]] = j;<br />
                     //cout&lt;&lt;i&lt;&lt;"   "&lt;&lt;num[i]&lt;&lt;"   "&lt;&lt;j&lt;&lt;endl;<br />
                 }<br />
             }<br />
         }<br />
         //预处理<br />
         for(int i=;i&lt;N;i++){<br />
             for(int j=;j&lt;=min(num[i]-;j++){<br />
                 int t = INF;<br />
                 for(int p=;p&lt;=j;p++){<br />
                     int q = j - p;<br />
                     t = min(t,pos[i][num[i]-q] - pos[i][p+] +  );<br />
                 }<br />
                 v[i][j] = M-t;<br />
             }<br />
             v[i][num[i]] = M;<br />
         }<br />
         //分组背包<br />
         for(int i=;i&lt;N;i++){<br />
             for(int j=T;j&gt;=;j--){<br />
                 for(int k = ;k&lt;=min(j,M);k++){<br />
                     dp[j] = max(dp[j] , dp[j-k]+v[i][k]);<br />
                 }<br />
             }<br />
         }<br />
         cout&lt;&lt;N*M-dp[T]&lt;&lt;endl;

     }<br />
     return ;<br />
 }<br />
 /*<br />
 9 1<br />
 0 1 1 1 1 1 6 7 8<br />
 */</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pmyrd9.html">vs2008所有DTE&period;ExecuteCommand命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jeyr8.html">python 之sqlalchemy many to many</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g5ykz8.html">转义字符（&bsol;）对JavaScript中JSON&period;parse的影响概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlxg16q.html">Alpha版本测试报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96n6pyq.html">两个有序数组中查找第K大数</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlg4wx9.html">IRP IO&lowbar;STACK&lowbar;LOCATION 《寒江独钓》内核学习笔记（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8enpyx8.html">MAC Java 开发环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydydnmq.html">解决：错误 14274&colon; 无法添加、更新或删除 SQL 服务器上的作业的问题一例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5e608.html">&amp;lt&semi;顶&amp;gt&semi;vim快捷键映射Map使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qder03v9.html">PHP MSSQL数据操作PDO API</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wempwq.html">MYSQL 专家 ----zhaiwx&lowbar;yinfeng</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxng7vd8.html">javascript--自己用的插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd3wr38.html">JAVA &dollar; JSP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgwxw8.html">HashMap实现分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgx6ge8.html">win10x64 批处理自动安装打印机</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ng2oq.html">React 环境增加Redux &comma;React-Redux</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wyek0q.html">Open quote is expected for attribute &amp;quot&semi;&lbrace;1&rcub;&amp;quot&semi; associated with an  element type  &amp;quot&semi;column&amp;quot&semi;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mely9.html">Hdoj 1176&period;免费馅饼 题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7olz1x8.html">postman charles设置代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjdnd79.html">android studio使用CMake和NDK，实现应用自身被卸载时打开某一网址</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pw1rly8.html">nodejs设置NODE&lowbar;ENV环境变量（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rg0048.html">解决mysql日志显示时间和&OpenCurlyDoubleQuote;Got an error reading communication packets&rdquo; 问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjnl2l9.html">转：C&num;综合揭秘&mdash;&mdash;细说多线程（上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90277rjq.html">【转】Spring学习---Bean配置的三种方式（XML、注解、Java类）介绍与对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjmnyo8.html">redis 配置文件示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve51dx9.html">Python3编写网络爬虫01-基本请求库urllib的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emey6z9.html">Ecstore Linux服务器环境基本配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmjz7e9.html">类与对象 - Java学习（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppnwmy9.html">HTML常用标签大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvwyr2q.html">（二十）ArcGIS JS 加载WMTS服务（超图示例）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
